=begin

earth_ctrlcmd.rb

Local mail library for a mail forwarding control script
Copyright (C) 2002-2003 Masaharu FUJITA

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the author by:
        e-mail: m@fjts.org
        url: http://fjts.org/~m/Soft/Ruby/earth.rb/
=end

class EarthCtrlCmd
  def initialize(header,body,from,to,passwd,received,messageid,from_emails,
		 to_email)
    @header = header
    @body = body
    @from = from
    @to = to
    @passwd = passwd
    @received = received
    @messageid = messageid
    @from_emails = from_emails
    @to_email = to_email

    @error_type = false
    @cmd_type, @passwd_on_mail, @array, @body = @body.split(/ /,4)
    if @array
      @array = @array.split(/,/)
    end
  end # def initialize

  def check
    # Check type
    case @cmd_type
    when ':REGET'
      @cmd_type = 'reget'
    when ':REPLY'
      @cmd_type = 'reply'
    when ':SEND'
      @cmd_type = 'send'
    else
      # This mail is not control command mail.
      @cmd_type = false
      return false
    end # case @cmd_type

    # Check from e-mail address
    from_email_flag = false
    @from_emails.each do |a|
      if @from == a
	from_email_flag = true
	break;
      end
    end

    if not from_email_flag
      @error_type = 'From Address'
      return false
    end

    # Check to e-mail address
    if @to != @to_email
      @error_type = 'To Address'
      return false
    end

    # Check password.
    if @passwd != @passwd_on_mail
      @error_type = 'Password'
      return false
    end

    # Check pattern of Received for control comannd.
    if not @received =~ @header['received']
      @error_type = 'Received'
      return false
    end

    # Check pattern of Message-ID for control comannd.
    if not @messageid =~ @header['message-id']
      @error_type = 'Message-ID'
      return false
    end

    return true
  end # def check

  def error
    @error_type
  end

  def type
    @cmd_type
  end

  def seq
    @array
  end

  def rest
    @body
  end
end # class EarthCtrlCmd
