=begin

earth_match.rb

Local mail library for a mail forwarding control script
Copyright (C) 2001-2003 Masaharu FUJITA

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the author by:
        e-mail: m@fjts.org
        url: http://fjts.org/~m/Soft/Ruby/earth.rb/
=end

# for rule matching
class EarthRuleMatch
  def  initialize(rule,header,all_header,from,to,cc,tocc,
		  default_cut_max_byte = 0, default_cut_max_num = 0,
		  default_reget_cut_max_byte = 0, default_reget_cut_max_num = 0)
    @rule = rule
    @header = header
    @all_header = all_header
    @from = from
    @to = to
    @cc = cc
    @tocc = tocc
    @cut_max_byte = default_cut_max_byte
    @cut_max_num = default_cut_max_num
    @reget_cut_max_byte = default_reget_cut_max_byte
    @reget_cut_max_num = default_reget_cut_max_num

    @is_send = false
    @match = nil
  end # def  initialize

  def judge
    if @rule == [] or not @rule
      return
    end

    mail_keyword = nil
    data = nil
    @rule.each do |data|
      case data[0].downcase
      when 'default'
	@match = 'default'
	break
      when 'all'
	mail_keyword = @all_header
      when 'tocc', 'destinations'
	mail_keyword = @tocc
      when 'to'
	mail_keyword = @to
      when 'cc'
	mail_keyword = @cc
      when 'from'
	mail_keyword = @from
      else
	tmp = data[0].downcase
	if @header.key?(tmp)
	  mail_keyword = @header[tmp]
	else
	  # error
	end
      end # case data[0].downcase

      if Regexp.new(data[1],"i") =~ mail_keyword
	# Match!
	@match = "#{data[0]}|#{data[1]}"
	break
      end
    end # @rule.each do |data|

    if data[2] != nil
      @cut_max_byte = data[2]
    end

    if data[3] != nil
      @cut_max_num = data[3]
    end

    if data[4] != nil
      @reget_cut_max_byte = data[4]
    end

    if data[5] != nil
      @reget_cut_max_num = data[5]
    end

    if not SendNoAtMarkAddress
      if not /.*@.*/ =~ @from
	@match = "From mail address is not include @."
	@cut_max_byte = 0
	@cut_max_num = 0
	$noinfo = true
      end # if not /.*@.*/ =~ @from
    end # if not SendNoAtMarkAddress

    if data[6] != nil
      eval(data[6])
    end
  end # def judge

  def match
    @match
  end

  def cut_max_byte
    @cut_max_byte
  end

  def cut_max_num
    @cut_max_num
  end

  def reget_cut_max_byte
    @reget_cut_max_byte
  end

  def reget_cut_max_num 
    @reget_cut_max_num
  end
end # class EarthRuleMatch
