=begin

earth_suspend.rb

Local mail library for a mail forwarding control script
Copyright (C) 2002-2003 Masaharu FUJITA

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the author by:
        e-mail: m@fjts.org
        url: http://fjts.org/~m/Soft/Ruby/earth.rb/
=end

class EarthSuspend
  def initialize(time,holiday,weekday_suspend,holiday_suspend,file,
		 directory,count)
    @time = time
    @holiday = holiday

    is_holiday = false
    @holiday.each do |data|
      if @time.strftime(data[0]) =~ data[1]
	is_holiday = true
	break
      end
    end

    if is_holiday
      @suspend = holiday_suspend
    else
      @suspend = weekday_suspend
    end

    @file = file
    @directory = directory
    @count_file = count

    @stats = 'normal'
    @before_stats = 'normal'

    # Get mqueue number and add number.
    if not File.exist?(@count_file)
      @count = 0
    else
      begin
        file = open(@count_file, "r")
        file.flock(File::LOCK_EX)
      rescue
        @count = 0
      else
        @count = file.gets.to_i
        file.flock(File::LOCK_UN)
        file.close
      end
    end # if not File.exist?(@count_file)
  end # def initialize

  def check
    if File.exist?(@file)
      @before_stats = 'suspend'
    end

    ct = @time.strftime("%H%M").to_i

    @suspend.each do |t|
      if t[0] <= ct and ct <= t[1]
	# Suspend time
	@stats = 'suspend'

	if @before_stats == 'normal'
          # Create suspend flag file.
          begin
            file = open(@file, "a")
          rescue
          else
            file.close
          end
	end # if @before_stats = 'normal'

	break
      end # if t[0] <= ct and ct <= t[1]
    end # @suspend.each do |t|

    if @stats == 'normal' and @before_stats == 'suspend'
      # Restart mail forwarding.
      @stats = 'restart'

      begin
        File.delete(Suspend)
      rescue
      else
      end
    end # if @stats == 'normal' and @before_stats == 'suspend'
  end # def check

  def save(string,index)
    if string == nil
      return
    end

    # Save mqueue number.
    begin
      file = open(@count_file, "w")
      file.flock(File::LOCK_EX)
    rescue
    else
      file.print @count + 1
      file.flock(File::LOCK_UN)
      file.close
    ensure
    end

    begin
      file = open(@directory + '/' + @count.to_s + '-' + index.to_s , "w")
    rescue
    else
      string.each do |line|
	file.print line
      end # @string.each do |line|

      file.close
    ensure
    end
  end # def save

  def stats
    @stats
  end

  def stats_change(stats)
    @stats = stats
  end

  def count
    @count
  end
end # def EarthSuspend
